function PlayerManager:on_headshot_dealt()
	local player_unit = self:player_unit()

	if not player_unit then
		return
	end

	local is_downed = game_state_machine:verify_game_state(GameStateFilters.downed)
	local swan_song_active = managers.player:has_activate_temporary_upgrade("temporary", "berserker_damage_multiplier")
	
	if is_downed or swan_song_active then
		return
	end

	self._message_system:notify(Message.OnHeadShot, nil, nil)

	local t = Application:time()

	if self._on_headshot_dealt_t and t < self._on_headshot_dealt_t then
		return
	end

	self._on_headshot_dealt_t = t + (tweak_data.upgrades.on_headshot_dealt_cooldown or 0)
	local damage_ext = player_unit:character_damage()
	local regen_armor_bonus = managers.player:upgrade_value("player", "headshot_regen_armor_bonus", 0)

	if damage_ext and regen_armor_bonus > 0 then --New code is here.
		if not managers.player:has_category_upgrade("player", "melee_damage_health_ratio_multiplier") then
			local max_health = damage_ext:_max_health()
			local health = damage_ext:get_real_health()
			local restored_health = math.min(2.5, regen_armor_bonus) --This makes it so that if your Bullseye restores more than 25 armor, it will not restore more than 25 HP.

			damage_ext:_check_update_max_health()
			damage_ext:restore_health(restored_health, true)
			damage_ext:restore_armor(regen_armor_bonus) --Delete this if you want it to regenerate HP only.
		else
			damage_ext:restore_armor(regen_armor_bonus)
		end
	end

	local regen_health_bonus = managers.player:upgrade_value("player", "headshot_regen_health_bonus", 0)

	if damage_ext and regen_health_bonus > 0 then
		damage_ext:restore_health(regen_health_bonus, true)
	end
end